/* NOTE!!! This script will be collapsed to single line! Do not forget ; and don't
 use single line comments! */
(function (scriptId) {
    var OBJECT_NAME = "MarketApplicationApiImpl";

    if (window.YandexApplicationsAPIBackend) {
        /* Already loaded */
        return;
    }

    var call_func_impl = function (javaMethodName, args) {
        if (!window[OBJECT_NAME]) {
            console.log("API ERROR: Can't find API implementation with name [" + OBJECT_NAME + "]");
            return;
        }
        var func = window[OBJECT_NAME][javaMethodName];
        if (!func) {
            console.log("API ERROR: Unknown method name " + OBJECT_NAME + ".[" + javaMethodName + "]");
            return;
        }
        return func.apply(window[OBJECT_NAME], args);
    };

    function call_func() {
        if (arguments.length == 0) {
            console.log("API ERROR: Method name missed");
            return;
        }

        var javaMethodName = arguments[0];
        var args = Array.prototype.splice.call(arguments, 1);
        /* we don't want any 'undefined' bullshit in Java code */
        args = Array.prototype.map.call(args, function (item) {
            if (item === undefined) {
                return null;
            } else if (typeof item !== "string") {
                return JSON.stringify(item);
            } else {
                return item;
            }
        });
        return call_func_impl(javaMethodName, args);
    }

    window.YandexApplicationsAPIBackend = {
        on: function (event, handlerName) {
        },
        event: {
            trigger: function (event, jsonData) {
                call_func('onEvent', event, jsonData);
            }
        }
    };
})